"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const webpack_cli_1 = __importDefault(require("webpack-cli"));
const startDevServer_1 = __importDefault(require("./startDevServer"));
const parseArgs_1 = __importDefault(require("./parseArgs"));
/**
 *
 * Creates a webpack compiler and runs the devServer
 *
 * @param {String[]} args - args processed from the CLI
 * @returns {Function} invokes the devServer API
 */
function serve(...args) {
    const cli = new webpack_cli_1.default();
    const core = cli.getCoreFlags();
    const { webpackArgs, devServerArgs } = parseArgs_1.default(cli, args);
    cli.getCompiler(webpackArgs, core).then((compiler) => {
        startDevServer_1.default(compiler, devServerArgs);
    });
}
exports.default = serve;
