
precision mediump float;

uniform sampler2D image1;

highp float rand(vec2 co)
{
    highp float a = 12.9898;
    highp float b = 78.233;
    highp float c = 43758.5453;
    highp float dt= dot(co.xy ,vec2(a,b));
    highp float sn= mod(dt,3.14);
    return fract(sin(sn) * c);
}

void main(){
    gl_FragColor = vec4(0.0, 1.0, 1.0, 1.0);
    float x = gl_FragCoord.x - 300.0;
    float y = gl_FragCoord.y - 300.0;
    float theta = atan(gl_FragCoord.y - 300.0, gl_FragCoord.x - 300.0);
    float r = sqrt(x * x + y * y);
    if(r > 250.0 && r < 270.0)
        gl_FragColor = texture2D(image1, vec2(fract((theta / 3.1415926 + 1.0) * 30.0), fract((r - 250.0) / 20.0)));

}